<template lang="pug">
BaseCard.x-daqtable(ref="mainCard" tabIndex='-1').highlightOnFocus
  template(v-slot:header)
    .d-flex.justify-content-between
      div
        h5.m-0 Overview
      .ml-auto
      ImportExportDropDownTools(:sources='sources' :isConfiguring='isConfiguring' @configure='configure()')
      button.mx-1.btn.btn-sm.btn-outline-secondary(type='button'
          @click="toggleShowDisabled"
          title='Show/hide disabled channels')
        i.fa.fa-expand-alt(v-if='!showDisabled')
        i.fa.fa-compress-alt(v-else)
      .mx-1.align-self-center.clickable(v-if='!inEdit'
                         @click='inEdit = true')
        kbd.keyHint.mr-2(v-if="showKeyHints") E
        i.fa.fa-cog
      .mx-1.align-self-center.clickable(v-if='inEdit'
                         @click='inEdit = false')
        kbd.keyHint.mr-2(v-if="showKeyHints") Esc
        i.fa.fa-times
  li.p-0.x-table(key='0')
    BaseModalLoader(:isLoading='isConfiguring')
    table.m-0.table.table-sm.table-hover.table-responsive-lg(
        @keydown.page-down.prevent='tableMoveFocus($event.target, 1)'
        @keydown.page-up.prevent='tableMoveFocus($event.target, -1)'
        @keydown.shift.enter.exact.prevent='tableMoveFocus($event.target, -1)'
        @keydown.enter.exact.prevent='tableMoveFocus($event.target, 1)'
        @mousedown.ctrl='isSelecting = true'
        @mouseup='isSelecting = false'
        @mouseleave='isSelecting = false')
      thead.bg-light.table-head
        tr.table-head
          th(v-if='inEdit')
            div
              kbd.keyHint.text-nowrap(v-if="showKeyHints") C-Click
            div
              kbd.keyHint.text-nowrap(v-if="showKeyHints") C-S-Click
          th.text-center(v-else)
          th.text-center Enabled
          th.text-center DAQ : Card : Channel
          th.text-center(v-show='!inEdit') Detector Name / ID
          th.text-center(v-show='inEdit') Detector Name
          th.text-center(v-show='inEdit') Detector ID
          th.text-center(v-show='!inEdit && mediaXL') Card Type
          th.text-center(v-show='!inEdit && mediaXL') Card Serial
          th.text-center Sample Rate [MS/s]
          th.text-center Sample Size [KS]
          th.text-center Time Window [ms]
          th.text-center(v-show='mediaXL') Delay [ns]

          th.text-center Full Scale [mV]
          th.text-center(v-show='inEdit') Offset [mV]
          th.text-center Lower Limit [mV]
          th.text-center(v-show='mediaXL' title='Impedance [Ω]') Imp. [Ω]

          th.text-center(title='Zero Suppression') ∅
          th.text-center ∅ Signal Leading Edge
          th.text-center ∅ Threshold [mV]
          th.text-center(v-show='mediaXL') ∅ Delay [ns]
          th.text-center(v-show='!inEdit && mediaXL') ∅ Pre/Post Samples [S]
          th.text-center(v-show='inEdit && mediaXL') ∅ Pre Samples [S]
          th.text-center(v-show='inEdit && mediaXL') ∅ Post Samples [S]

      tbody(:class='{ selecting: isSelecting }')
        template(v-for='chan in chanList')
          DaqTableChannel(:key='chan.id' :ref='chan.id'
            @mousedown.native.ctrl.prevent='onMouseSelect($event, chan.id)'
            @mouseenter.native.ctrl='onMouseSelect($event, chan.id)'
            @push-value='onPushValue($event, chan.id)'
            @gen-detector-id='onGenDetectorId($event)'
            :showDisabled='showDisabled' :inEdit='inEdit'
            :daq='chan.daq' :card='chan.card' :channel='chan.channel')
  li(key="1" v-show='inEdit && !isConfiguring')
    button.btn.btn-secondary.float-right.mx-1(type='submit' @click='cancel()')
      kbd.keyHint.mr-2(v-if="showKeyHints") Esc
      | Cancel
    button.btn.btn-primary.float-right.mx-1(type='submit' @click='configure()')
      kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
      | Configure
</template>
<script>
export { default } from './DaqTable.vue.js';
</script>
<style lang='scss'>
.x-daqtable {
  .x-table { overflow-y: auto; }
  .table {
    td, th {
      text-align: center;
      font-size: 0.9rem;
    }
    td {
      vertical-align: middle;
    }
    tbody.selecting {
      cursor: cell!important;
    }
  }
}
</style>
